// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_LF_MOM_BACKEND/grmi"
	meta "LAPP_LF_MOM_BACKEND/meta/api"
	model "LAPP_LF_MOM_BACKEND/models/api"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : ACCWOWORKORDERHEADERDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : ACCWOWORKORDERHEADER的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-05-12 14:17:07
 *
 ******************************************************************************/
type ACCWOWORKORDERHEADERDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewACCWOWORKORDERHEADERDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个ACCWOWORKORDERHEADERDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *

 * @Return Value             : ACCWOWORKORDERHEADERDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-05-12 14:17:07
 *
 ******************************************************************************/
func NewACCWOWORKORDERHEADERDAOImplement(session *xorm.Session, userid string) *ACCWOWORKORDERHEADERDAOImplement {
	return &ACCWOWORKORDERHEADERDAOImplement{session, &meta.ACCWOWORKORDERHEADER, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERHEADERDAO.InsertOne
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERHEADERDAOImplement) InsertOne(entity *model.ACCWOWORKORDERHEADER) error {

	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERHEADERDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERHEADERDAOImplement) DeleteOne(wONO string) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{wONO}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERHEADERDAO.SelectOne
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERHEADERDAOImplement) SelectOne(wONO string) (*model.ACCWOWORKORDERHEADER, error) {
	var data model.ACCWOWORKORDERHEADER
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{wONO}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERHEADERDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERHEADERDAOImplement) UpdateOne(entity *model.ACCWOWORKORDERHEADER) error {

	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERHEADERDAO.Insert
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERHEADERDAOImplement) Insert(entities *[]model.ACCWOWORKORDERHEADER) error {
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERHEADERDAO.Delete
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERHEADERDAOImplement) Delete(entities *[]model.ACCWOWORKORDERHEADER) error {
	for _, entity := range *entities {

		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERHEADERDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERHEADERDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERHEADERDAO.Select
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERHEADERDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field, limit int) ([]model.ACCWOWORKORDERHEADER, error) {

	parameters := []interface{}{}
	where := "1 = 1"

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.ACCWOWORKORDERHEADER, 0, 10)
	err := session.Limit(limit).Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERHEADERDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERHEADERDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by "
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.ACCWOWORKORDERHEADER, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERHEADERDAO.Update
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERHEADERDAOImplement) Update(entities *[]model.ACCWOWORKORDERHEADER) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]

		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERHEADERDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERHEADERDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.ACCWOWORKORDERHEADER, columns ...string) error {

	parameters := []interface{}{}
	where := ""

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/api/ACCWOWORKORDERHEADERDAO.UpdateForQty
 *
 ******************************************************************************/
func (impl *ACCWOWORKORDERHEADERDAOImplement) UpdateForQty(entity *model.ACCWOWORKORDERHEADER, qty int) error {
	where := fmt.Sprintf("%s = ? and %s = ?", meta.ACCWOWORKORDERHEADER_WONO.ColumnName, meta.ACCWOWORKORDERHEADER_QUANTITY.ColumnName)
	col, err := impl.session.Table(impl.meta.TableName).Where(where, entity.WONO, qty).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	if col <= 0 {
		return grmi.NewBusinessError("对应的mes WorkOrder数据已更新")
	}
	return nil
}